VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Arcus HID API Library VB Test Application"
   ClientHeight    =   4650
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   5835
   LinkTopic       =   "Form1"
   ScaleHeight     =   4650
   ScaleWidth      =   5835
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox TextResponse 
      BackColor       =   &H00E0E0E0&
      Enabled         =   0   'False
      Height          =   375
      Left            =   2760
      TabIndex        =   9
      Top             =   3840
      Width           =   2895
   End
   Begin VB.CommandButton SendCommand 
      Caption         =   "Send Command"
      Height          =   375
      Left            =   240
      TabIndex        =   8
      Top             =   3000
      Width           =   2295
   End
   Begin VB.TextBox TextCommand 
      Height          =   375
      Left            =   2760
      TabIndex        =   7
      Top             =   3000
      Width           =   2895
   End
   Begin VB.CommandButton CloseHid 
      Caption         =   "CloseArcusHID"
      Height          =   375
      Left            =   3120
      TabIndex        =   6
      Top             =   2160
      Width           =   2295
   End
   Begin VB.TextBox IndexHid 
      Height          =   375
      Left            =   2760
      TabIndex        =   5
      Text            =   "0"
      Top             =   1440
      Width           =   735
   End
   Begin VB.CommandButton OpenHID 
      Caption         =   "OpenArcusHID"
      Height          =   375
      Left            =   240
      TabIndex        =   4
      Top             =   2160
      Width           =   2295
   End
   Begin VB.TextBox NameHID 
      BackColor       =   &H00E0E0E0&
      Enabled         =   0   'False
      Height          =   375
      Left            =   3960
      TabIndex        =   3
      Top             =   1440
      Width           =   1455
   End
   Begin VB.CommandButton GetHidName 
      Caption         =   "GetArcusHIDName"
      Height          =   375
      Left            =   240
      TabIndex        =   2
      Top             =   1440
      Width           =   2295
   End
   Begin VB.TextBox NumHIDs 
      BackColor       =   &H00E0E0E0&
      Enabled         =   0   'False
      Height          =   375
      Left            =   2760
      TabIndex        =   1
      Top             =   600
      Width           =   735
   End
   Begin VB.CommandButton GetNumHIDs 
      Caption         =   "GetArcusHIDnumber"
      Height          =   375
      Left            =   240
      TabIndex        =   0
      Top             =   600
      Width           =   2295
   End
   Begin VB.Label Label2 
      Caption         =   "Dev Num"
      Height          =   255
      Left            =   2760
      TabIndex        =   11
      Top             =   1200
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Response"
      Height          =   255
      Left            =   1440
      TabIndex        =   10
      Top             =   3840
      Width           =   1095
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Declarations of the ARCUS HID DLL APIs
Private Declare Function GetArcusHIDnumber Lib "HidApiDll" () As Long

Private Declare Function GetArcusHIDName Lib "HidApiDll" _
(ByVal HidIndex As Long, ByVal HidName As String) As Long

Private Declare Function OpenArcusHID Lib "HidApiDll" _
(ByRef HidHandle As Long, ByVal HidName As String) As Long

Private Declare Function CloseArcusHID Lib "HidApiDll" _
(ByVal HidHandle As Long) As Long

Private Declare Function SendReceiveArcusHID Lib "HidApiDll" _
(ByVal HidHandle As Long, ByVal command As String, ByVal reply As String) As Long

' Global Handle to the ARCUS HID
Dim HidHandle As Long

Private Sub CloseHid_Click()
    Dim retVal As Long

    ' Close the desired ARCUS-HID
    retVal = CloseArcusHID(HidHandle)
    
    If (retVal = 1) Then
        MsgBox "Closed ARCUS HID Successfully"
    Else
        MsgBox "Close ARCUS HID failure"
    End If
End Sub

Private Sub GetHidName_Click()
    Dim HidIndex As Long
    Dim HidName As String * 12
    Dim retVal As Long
    
    ' Get the index of desired ARCUS-HID from text box control
    HidIndex = Val(IndexHid.Text)
    
    ' Get the serial string name of the desired ARCUS-HID
    retVal = GetArcusHIDName(HidIndex, HidName)
    
    If (retVal = 1) Then
        MsgBox "Got the serial string name of the ARCUS HID successfully"
        ' Display the serial string name in text box control
        NameHID.Text = HidName
    Else
        MsgBox "Error in getting the serial string name of the ARCUS HID"
        NameHID.Text = ""
    End If
End Sub

Private Sub GetNumHIDs_Click()
    Dim numberHIDs As Long
    
    ' Get the number of connected ARCUS-HIDs
    numberHIDs = GetArcusHIDnumber()
    
    ' Display the number in text box control
    NumHIDs.Text = numberHIDs
End Sub

Private Sub OpenHID_Click()
    Dim retVal As Long

    ' Get the handle to the desired ARCUS-HID (name is previously set in 'GetHidName_Click')
    retVal = OpenArcusHID(HidHandle, NameHID.Text)
    
    If (retVal = 1) Then
        MsgBox "Opened ARCUS HID Successfully"
    Else
        MsgBox "Open ARCUS HID failure"
    End If
End Sub

Private Sub SendCommand_Click()
    Dim command As String * 63
    Dim reply As String * 63
    Dim retVal As Long
    
    ' Check the length of the Command string
    If (Len(TextCommand.Text) > 63) Then
        MsgBox "Command string can be maximum 63 bytes long"
        TextResponse.Text = ""
    Else
        ' Get the command string that has to be sent to the desired ARCUS-HID from text box control
        command = TextCommand.Text
        
        ' Send the command to the desired ARCUS-HID and receive a response from the ARCUS-HID
        retVal = SendReceiveArcusHID(HidHandle, command, reply)
        
        If (retVal = 1) Then
            MsgBox "Successful transaction"
            ' Display the reply message received from the ARCUS-HID in text box control
            TextResponse.Text = reply
        Else
            If (retVal = 0) Then
                MsgBox "Warning! Device responded with an 'Error' response string"
                ' Display the error message received from the ARCUS-HID in text box control
                TextResponse.Text = reply
            Else
                Dim errorString As String * 50
                ' Error in communication with the ARCUS-HID, display the returned error code
                errorString = "Error! UnSuccessful transaction" + ", Error Code = " + Format(retVal)
                MsgBox errorString
                TextResponse.Text = ""
            End If
        End If
    End If
End Sub
